commit 5a3921a14e0d1a5c4a3030d83b6a4bf3525d3704
Author: Sofia Papagiannaki <papagian@gmail.com>
Date:   Mon Feb 18 22:20:50 2013 +0200

    Fix astakos settings documentation

diff --git a/snf-astakos-app/conf/20-snf-astakos-app-settings.conf b/snf-astakos-app/conf/20-snf-astakos-app-settings.conf
index a1baa6c..2c98657 100644
--- a/snf-astakos-app/conf/20-snf-astakos-app-settings.conf
+++ b/snf-astakos-app/conf/20-snf-astakos-app-settings.conf
@@ -2,10 +2,6 @@
 # to be this many hours after their creation time.
 #ASTAKOS_AUTH_TOKEN_DURATION = 30 * 24
 
-# Authenticate via Twitter.
-#ASTAKOS_TWITTER_KEY = ''
-#ASTAKOS_TWITTER_SECRET = ''
-
 #ASTAKOS_DEFAULT_USER_LEVEL = 4
 
 #ASTAKOS_INVITATIONS_PER_LEVEL = {
@@ -17,9 +13,10 @@
 #}
 
 # Address to use for outgoing emails
-#ASTAKOS_DEFAULT_FROM_EMAIL = 'GRNET Cloud <no-reply@grnet.gr>'
 #ASTAKOS_DEFAULT_CONTACT_EMAIL = 'support@cloud.grnet.gr'
-#ASTAKOS_DEFAULT_ADMIN_EMAIL = 'admin@cloud.grnet.gr'
+
+#SERVER_EMAIL = None
+#ADMINS = None
 
 # Identity Management enabled modules
 # Supported modules are: 'local', 'twitter' and 'shibboleth'
@@ -51,7 +48,7 @@
 # http://www.google.com/recaptcha/whyrecaptcha 
 #ASTAKOS_RECAPTCHA_PUBLIC_KEY = ''
 #ASTAKOS_RECAPTCHA_PRIVATE_KEY = ''
-#ASTAKOS_RECAPTCHA_OPTIONS = {'theme':'white'}
+#ASTAKOS_RECAPTCHA_OPTIONS = {'theme': 'custom', 'custom_theme_widget': 'okeanos_recaptcha'}
 #ASTAKOS_RECAPTCHA_USE_SSL = True
 #ASTAKOS_RECAPTCHA_ENABLED = False
 
@@ -60,7 +57,7 @@
 
 # Queue for billing.
 #'rabbitmq://guest:guest@localhost:5672/astakos'
-#QUEUE_CONNECTION = None 
+#ASTAKOS_QUEUE_CONNECTION = None 
 
 # Set where the user should be redirected after logout
 #ASTAKOS_LOGOUT_NEXT = ''
@@ -123,23 +120,163 @@
 #ASTAKOS_QUOTAHOLDER_TOKEN = ''
 
 # Set the cloud service properties
-# SERVICES = getattr(settings, 'ASTAKOS_SERVICES',
-#                    {'cyclades': {'url':'https://node1.example.com/ui/',
-#                                  'quota': {'vm': 2}},
-#                     'pithos+':  {'url':'https://node2.example.com/ui/',
-#                                  'quota': {'diskspace': 50 * 1024 * 1024 * 1024}}})
+# ASTAKOS_SERVICES = {
+#    'cyclades': {
+##        'url': 'https://node1.example.com/ui/',
+#        'resources': [{
+#            'name':'disk',
+#            'group':'compute',
+#            'uplimit':30*1024*1024*1024,
+#            'unit':'bytes',
+#            'desc': 'Virtual machine disk size'
+#            },{
+#            'name':'cpu',
+#            'group':'compute',
+#            'uplimit':6,
+#            'desc': 'Number of virtual machine processors'
+#            },{
+#            'name':'ram',
+#            'group':'compute',
+#            'uplimit':6*1024*1024*1024,
+#            'unit':'bytes',
+#            'desc': 'Virtual machines'
+#            },{
+#            'name':'vm',
+#            'group':'compute',
+#            'uplimit':2,
+#            'desc': 'Number of virtual machines'
+#            },{
+#            'name':'network.private',
+#            'group':'network',
+#            'uplimit':1,
+#            'desc': 'Private networks'
+#            }
+#        ]
+#    },
+#    'pithos+': {
+##        'url': 'https://node2.example.com/ui/',
+#        'resources':[{
+#            'name':'diskspace',
+#            'group':'storage',
+#            'uplimit':5 * 1024 * 1024 * 1024,
+#            'unit':'bytes',
+#            'desc': 'Pithos account diskspace'
+#            }]
+#    }
+#}
 
 # Set the billing URI
 #ASTAKOS_AQUARIUM_URL = ''
 
 # Set how many objects should be displayed per page
-#PAGINATE_BY = getattr(settings, 'ASTAKOS_PAGINATE_BY', 10)
+#ASTAKOS_PAGINATE_BY = 10
+# Set how many objects should be displayed per page in show all groups page
+#ASTAKOS_PAGINATE_BY_ALL = 15
 
 # Enforce token renewal on password change/reset
-# NEWPASSWD_INVALIDATE_TOKEN = getattr(settings, 'ASTAKOS_NEWPASSWD_INVALIDATE_TOKEN', True)
+#ASTAKOS_NEWPASSWD_INVALIDATE_TOKEN = True
+
+#ASTAKOS_USAGE_UPDATE_INTERVAL = 5000
+
+#ASTAKOS_RESOURCES_PRESENTATION_DATA = {
+#        'groups': {
+#             'compute': {
+#                'help_text':'Compute resources (amount of VMs, CPUs, RAM, System disk) ',
+#                'is_abbreviation':False,
+#                'report_desc':'',
+#                 'verbose_name':'compute',
+#            },
+#            'storage': {
+#                'help_text':'Storage resources (amount of space to store files on Pithos) ',
+#                'is_abbreviation':False,
+#                'report_desc':'',
+#                 'verbose_name':'storage',
+#            },
+#            'network': {
+#                'help_text':' Network resources (amount of Private Networks)  ',
+#                'is_abbreviation':False,
+#                'report_desc':'',
+#                'verbose_name':'network',
+#            },
+#        },
+#        'resources': {
+#            'pithos+.diskspace': {
+#                'help_text':'This is the space on Pithos for storing files and VM Images. ',
+#                'help_text_input_each':'This is the total amount of space on Pithos that will be granted to each user of this Project ',
+#                'is_abbreviation':False,
+#                'report_desc':'Storage Space',
+#                'placeholder':'eg. 10GB',
+#                'verbose_name':'Storage Space',
+#            },
+#            'cyclades.disk': {
+#                'help_text':'This is the System Disk that the VMs have that run the OS ',
+#                'help_text_input_each':"This is the total amount of System Disk that will be granted to each user of this Project (this refers to the total System Disk of all VMs, not each VM's System Disk)  ",
+#                'is_abbreviation':False,
+#                'report_desc':'System Disk',
+#                'placeholder':'eg. 5GB, 2GB etc',
+#                'verbose_name':'System Disk'
+#            },
+#            'cyclades.ram': {
+#                'help_text':'RAM used by VMs ',
+#                'help_text_input_each':'This is the total amount of RAM that will be granted to each user of this Project (on all VMs)  ',
+#                'is_abbreviation':True,
+#                'report_desc':'RAM',
+#                'placeholder':'eg. 4GB',
+#                'verbose_name':'ram'
+#            },
+#            'cyclades.cpu': {
+#                'help_text':'CPUs used by VMs ',
+#                'help_text_input_each':'This is the total number of CPUs that will be granted to each user of this Project (on all VMs)  ',
+#                'is_abbreviation':True,
+#                'report_desc':'CPUs',
+#                'placeholder':'eg. 1',
+#                'verbose_name':'cpu'
+#            },
+#            'cyclades.vm': {
+#                'help_text':'These are the VMs one can create on the Cyclades UI ',
+#                'help_text_input_each':'This is the total number of VMs that will be granted to each user of this Project ',
+#                'is_abbreviation':True,
+#                'report_desc':'Virtual Machines',
+#                'placeholder':'eg. 2',
+#                'verbose_name':'vm',
+#            },
+#            'cyclades.network.private': {
+#                'help_text':'These are the Private Networks one can create on the Cyclades UI. ',
+#                'help_text_input_each':'This is the total number of Private Networks that will be granted to each user of this Project ',
+#                'is_abbreviation':False,
+#                'report_desc':'Private Networks',
+#                'placeholder':'eg. 1',
+#                'verbose_name':'private network'
+#            }
+#
+#        },
+#
+#        'groups_order': ['storage', 'compute', 'network'],
+#        'resources_order': ['pithos+.diskspace', 'cyclades.disk',
+#                            'cyclades.cpu', 'cyclades.ram', 'cyclades.vm',
+#                            'cyclades.network.private']
+#
+#    }
 
 # Permit local account migration
-# ENABLE_LOCAL_ACCOUNT_MIGRATION = getattr(settings, 'ASTAKOS_ENABLE_LOCAL_ACCOUNT_MIGRATION', True)
+#ASTAKOS_ENABLE_LOCAL_ACCOUNT_MIGRATION = True
+
+# Strict shibboleth usage
+#ASTAKOS_SHIBBOLETH_REQUIRE_NAME_INFO = False
+
+#ASTAKOS_PROJECT_MEMBER_JOIN_POLICIES = {'1':'automatically accepted',
+#                                 '2':'owner accepts',
+#                                 '3':'closed'}
+
+#ASTAKOS_PROJECT_MEMBER_LEAVE_POLICIES' = {'1':'automatically accepted',
+#                                 '2':'owner accepts',
+#                                 '3':'closed'}
+
+#ASTAKOS_ACTIVATION_REDIRECT_URL = "/im/landing"
+
+# If true, this enables a ui compatibility layer for the introduction of UUIDs
+# in identity management. WARNING: Setting to True will break your installation.
+#ASTAKOS_TRANSLATE_UUIDS = False
 
 # UUIDs of users that can approve or deny project applications from the web.
 # ASTAKOS_PROJECT_ADMINS = set() # e.g. set(['01234567-89ab-cdef-0123-456789abcdef'])
@@ -148,3 +285,16 @@
 # of UUIDs in identity management.
 # WARNING: Setting to True will break your installation.
 # ASTAKOS_TRANSLATE_UUIDS = False
+
+# OAuth2 Twitter credentials.
+#ASTAKOS_TWITTER_KEY = ''
+#ASTAKOS_TWITTER_SECRET = ''
+#ASTAKOS_TWITTER_AUTH_FORCE_LOGIN = False
+
+# OAuth2 Google credentials
+#ASTAKOS_GOOGLE_CLIENT_ID = ''
+#ASTAKOS_GOOGLE_SECRET = ''
+
+# OAuth2 LinkedIn credentials.
+#ASTAKOS_LINKEDIN_TOKEN = ''
+#ASTAKOS_LINKEDIN_SECRET = ''